/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         plpgpsm_yyparse
#define yylex           plpgpsm_yylex
#define yyerror         plpgpsm_yyerror
#define yylval          plpgpsm_yylval
#define yychar          plpgpsm_yychar
#define yydebug         plpgpsm_yydebug
#define yynerrs         plpgpsm_yynerrs
#define yylloc          plpgpsm_yylloc

/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "gram.y"

/*-------------------------------------------------------------------------
 *
 * gram.y				- Parser for the PL/pgPSM procedural language
 *
 * Portions Copyright (c) 1996-2012, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/pl/plpgpsm/src/gram.y
 *
 *-------------------------------------------------------------------------
 */

#include "plpgpsm.h"

#include "catalog/pg_type.h"
#include "parser/parse_type.h"
#include "parser/scanner.h"
#include "parser/scansup.h"

/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (Rhs)[0]; \
	} while (0)

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree


typedef struct
{
	int			location;
	int			leaderlen;
} sql_error_callback_arg;

#define parser_errposition(pos)  plpgpsm_scanner_errposition(pos)

union YYSTYPE;					/* need forward reference for tok_is_keyword */

static PLpgPSM_ESQL *read_esql(int until1, int until2, int until3, const char *expected,
						 bool is_expression, int *endtoken, int startlocation,
						 bool is_optional);

static void check_labels(const char *label1, const char *label2);
static void check_labels_in_current_scope(List *stmts, PLpgPSM_astnode *stmt);
static PLpgPSM_ident *read_typename(void);
static void set_parent(List *nodes, PLpgPSM_astnode *parent);
static PLpgPSM_declare_variable *new_declvar(List *variable_list, PLpgPSM_ident *typename,
										PLpgPSM_ESQL *expr);
static PLpgPSM_referer *new_referer(PLpgPSM_ident *ident, PLpgPSM_astnode *ref);
static PLpgPSM_ident *new_ident_var(char *scope, char *name, int location);
static PLpgPSM_stmt_assign *new_stmt_assign(PLpgPSM_referer *referer,
					    List *idents,
							    PLpgPSM_ESQL *expr, int location);
static PLpgPSM_eb_stmt *new_search_case(PLpgPSM_ESQL *expr,
							List *case_when_list,
							PLpgPSM_eb_stmt *else_stmts,
										    int location);
static void cast_to_boolean(PLpgPSM_ESQL *expr);
static PLpgPSM_astnode *declare_prefetch(void);
static bool is_unreserved_keyword(int tok);
static PLpgPSM_astnode *for_prefetch(void);
static PLpgPSM_astnode *newsignal(PLpgPSM_astnode_enum type, PLpgPSM_condition *condition,
								    List *signal_info_list,
								    int location);
static PLpgPSM_condition *condition(PLpgPSM_condition_enum type, int sqlstate, char *name,
									    int location);




/* Line 268 of yacc.c  */
#line 165 "gram.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENT = 258,
     FCONST = 259,
     SCONST = 260,
     BCONST = 261,
     XCONST = 262,
     Op = 263,
     ICONST = 264,
     PARAM = 265,
     TYPECAST = 266,
     DOT_DOT = 267,
     COLON_EQUALS = 268,
     T_WORD = 269,
     T_CWORD = 270,
     AS = 271,
     ATOMIC = 272,
     BEGIN = 273,
     CASE = 274,
     CLOSE = 275,
     CONDITION = 276,
     CONDITION_IDENTIFIER = 277,
     CONTINUE = 278,
     CURRENT = 279,
     CURSOR = 280,
     DECLARE = 281,
     DEFAULT = 282,
     DETAIL_TEXT = 283,
     DIAGNOSTICS = 284,
     DO = 285,
     ELSE = 286,
     ELSEIF = 287,
     END = 288,
     EXIT = 289,
     FETCH = 290,
     FOR = 291,
     FROM = 292,
     FOUND = 293,
     GET = 294,
     HANDLER = 295,
     HINT_TEXT = 296,
     IF = 297,
     INTO = 298,
     ITERATE = 299,
     LEAVE = 300,
     LOOP = 301,
     MESSAGE_TEXT = 302,
     NO = 303,
     NOT = 304,
     OPEN = 305,
     PRINT = 306,
     REPEAT = 307,
     RESIGNAL = 308,
     RETURN = 309,
     RETURNED_SQLCODE = 310,
     RETURNED_SQLSTATE = 311,
     ROW_COUNT = 312,
     SCROLL = 313,
     SELECT = 314,
     SET = 315,
     SIGNAL = 316,
     SQLCODE = 317,
     SQLEXCEPTION = 318,
     SQLSTATE = 319,
     SQLWARNING = 320,
     STACKED = 321,
     THEN = 322,
     UNTIL = 323,
     VALUE = 324,
     WHEN = 325,
     WHILE = 326,
     UNDO = 327
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 90 "gram.y"

		core_YYSTYPE			core_yystype;
		/* these fields must match core_YYSTYPE: */
		int						ival;
		char					*str;
		const char				*keyword;

		PLword					word;
		PLcword					cword;
		bool					boolean;
		Oid						oid;
		PLpgPSM_astnode			*astnode;
		PLpgPSM_ESQL			*esql;
		List				*list;
		PLpgPSM_eb_stmt			*eb;
		PLpgPSM_condition		*condition;
		PLpgPSM_ident			*ident;
		PLpgPSM_referer		*referer;
		PLpgPSM_variable	*variable;
		PLpgPSM_signal_info_enum		signal_info_enum;
		PLpgPSM_diagarea_type		diagarea;
		PLpgPSM_diag_info_type		diag_info_type;



/* Line 293 of yacc.c  */
#line 299 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 324 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  80
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   434

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  78
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  62
/* YYNRULES -- Number of rules.  */
#define YYNRULES  141
/* YYNRULES -- Number of states.  */
#define YYNSTATES  221

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   327

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      75,    76,     2,     2,    74,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    73,
       2,    77,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    14,    16,    18,
      20,    22,    24,    26,    28,    30,    32,    34,    36,    38,
      40,    42,    44,    47,    48,    52,    54,    61,    68,    77,
      79,    80,    84,    86,    89,    94,   101,   106,   107,   111,
     113,   115,   118,   120,   122,   124,   127,   128,   132,   134,
     135,   138,   145,   149,   151,   155,   159,   161,   163,   165,
     167,   176,   179,   180,   182,   183,   186,   188,   193,   194,
     201,   202,   205,   207,   212,   219,   228,   229,   238,   239,
     241,   242,   244,   245,   248,   251,   253,   255,   257,   259,
     261,   263,   265,   267,   269,   271,   273,   275,   277,   279,
     281,   283,   285,   287,   290,   291,   294,   298,   300,   301,
     304,   307,   312,   321,   324,   329,   331,   335,   338,   343,
     345,   347,   351,   353,   357,   359,   361,   363,   368,   370,
     372,   373,   377,   379,   383,   385,   387,   389,   391,   393,
     395,   397
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      79,     0,    -1,    80,    -1,    80,    73,    -1,    93,    -1,
      98,    -1,   104,    -1,   115,    -1,   116,    -1,   108,    -1,
     109,    -1,   111,    -1,   119,    -1,   121,    -1,    83,    -1,
     124,    -1,   125,    -1,   126,    -1,   127,    -1,   128,    -1,
     129,    -1,   134,    -1,    82,    73,    -1,    -1,    82,    73,
      80,    -1,    80,    -1,   113,    18,    84,    81,    33,   114,
      -1,   113,    18,    84,    85,    33,   114,    -1,   113,    18,
      84,    85,    73,    81,    33,   114,    -1,    17,    -1,    -1,
      85,    73,    86,    -1,    86,    -1,    26,    87,    -1,    26,
      87,    21,    90,    -1,    26,    87,    40,    36,    88,    80,
      -1,    26,    87,    25,    36,    -1,    -1,    88,    74,    89,
      -1,    89,    -1,    91,    -1,    49,    38,    -1,    65,    -1,
      63,    -1,    14,    -1,    36,    91,    -1,    -1,    64,    92,
       5,    -1,    69,    -1,    -1,    60,    94,    -1,    60,    75,
      96,    76,    77,    75,    -1,    94,    74,    95,    -1,    95,
      -1,    97,    77,   123,    -1,    96,    74,    97,    -1,    97,
      -1,    14,    -1,    15,    -1,   118,    -1,    42,   103,    67,
      81,   100,    99,    33,    42,    -1,    31,    81,    -1,    -1,
     101,    -1,    -1,   101,   102,    -1,   102,    -1,    32,   103,
      67,    81,    -1,    -1,    19,   105,   106,    99,    33,    19,
      -1,    -1,   106,   107,    -1,   107,    -1,    70,   103,    67,
      81,    -1,   113,    46,    81,    33,    46,   114,    -1,   113,
      71,   110,    30,    81,    33,    71,   114,    -1,    -1,   113,
      52,    81,    68,   112,    33,    52,   114,    -1,    -1,    14,
      -1,    -1,    14,    -1,    -1,    45,   117,    -1,    44,   117,
      -1,    14,    -1,    17,    -1,    38,    -1,    49,    -1,    51,
      -1,    63,    -1,    64,    -1,    65,    -1,    47,    -1,    41,
      -1,    28,    -1,    66,    -1,    24,    -1,    29,    -1,    55,
      -1,    56,    -1,    57,    -1,    22,    -1,    54,   120,    -1,
      -1,    51,   122,    -1,   122,    74,   123,    -1,   123,    -1,
      -1,    50,    97,    -1,    20,    97,    -1,    35,    97,    43,
      96,    -1,   113,    36,   139,    30,    81,    33,    36,   114,
      -1,    61,   130,    -1,    61,   130,    60,   131,    -1,    53,
      -1,    53,    60,   131,    -1,    53,   130,    -1,    53,   130,
      60,   131,    -1,    14,    -1,    91,    -1,   131,    74,   132,
      -1,   132,    -1,   133,    77,   123,    -1,    47,    -1,    28,
      -1,    41,    -1,    39,   135,    29,   136,    -1,    24,    -1,
      66,    -1,    -1,   136,    74,   137,    -1,   137,    -1,    97,
      77,   138,    -1,    56,    -1,    55,    -1,    47,    -1,    28,
      -1,    41,    -1,    57,    -1,    22,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   224,   224,   225,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   250,   251,   255,   260,   279,   296,   307,   321,
     322,   326,   393,   400,   409,   431,   443,   468,   472,   473,
     477,   478,   479,   480,   481,   485,   486,   490,   512,   513,
     524,   541,   552,   553,   557,   564,   565,   569,   573,   579,
     605,   627,   636,   642,   643,   647,   648,   652,   664,   691,
     720,   724,   725,   729,   746,   764,   781,   791,   808,   816,
     826,   832,   833,   841,   856,   871,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   899,   933,   943,   958,   959,   963,   971,
     992,  1013,  1046,  1067,  1071,  1083,  1087,  1091,  1095,  1102,
    1103,  1107,  1121,  1128,  1147,  1148,  1149,  1159,  1177,  1178,
    1179,  1183,  1184,  1188,  1205,  1206,  1207,  1208,  1209,  1210,
    1211,  1218
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "T_WORD", "T_CWORD", "AS", "ATOMIC", "BEGIN", "CASE", "CLOSE",
  "CONDITION", "CONDITION_IDENTIFIER", "CONTINUE", "CURRENT", "CURSOR",
  "DECLARE", "DEFAULT", "DETAIL_TEXT", "DIAGNOSTICS", "DO", "ELSE",
  "ELSEIF", "END", "EXIT", "FETCH", "FOR", "FROM", "FOUND", "GET",
  "HANDLER", "HINT_TEXT", "IF", "INTO", "ITERATE", "LEAVE", "LOOP",
  "MESSAGE_TEXT", "NO", "NOT", "OPEN", "PRINT", "REPEAT", "RESIGNAL",
  "RETURN", "RETURNED_SQLCODE", "RETURNED_SQLSTATE", "ROW_COUNT", "SCROLL",
  "SELECT", "SET", "SIGNAL", "SQLCODE", "SQLEXCEPTION", "SQLSTATE",
  "SQLWARNING", "STACKED", "THEN", "UNTIL", "VALUE", "WHEN", "WHILE",
  "UNDO", "';'", "','", "'('", "')'", "'='", "$accept", "sqlpsm_statement",
  "stmt", "stmts_opt", "stmts", "stmt_compound", "opt_atomic",
  "declaration_list", "declaration", "declare_prefetch", "condition_list",
  "condition", "opt_sqlstate", "sqlstate", "opt_value", "stmt_assign",
  "simple_assign_list", "simple_assign", "target_list", "target",
  "stmt_if", "opt_else_stmts", "opt_elseif_then_list", "elseif_then_list",
  "elseif_then", "expr_until_then", "stmt_case", "opt_expr_until_when",
  "case_when_list", "case_when", "stmt_loop", "stmt_while",
  "expr_until_do", "stmt_repeat_until", "expr_until_end", "opt_label",
  "opt_end_label", "stmt_leave", "stmt_iterate", "label",
  "unreserved_keyword", "stmt_return", "opt_expr", "stmt_print",
  "expr_list", "expr_until_comma_semi", "stmt_open", "stmt_close",
  "stmt_fetch", "stmt_for", "stmt_signal", "stmt_resignal",
  "signaled_condition", "signal_info_list", "signal_info",
  "signal_info_type", "stmt_diagnostics", "diag_area_opt",
  "diag_info_list", "diag_info", "diag_info_type", "for_prefetch", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,    59,    44,    40,    41,    61
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    78,    79,    79,    80,    80,    80,    80,    80,    80,
      80,    80,    80,    80,    80,    80,    80,    80,    80,    80,
      80,    80,    81,    81,    82,    82,    83,    83,    83,    84,
      84,    85,    85,    86,    86,    86,    86,    87,    88,    88,
      89,    89,    89,    89,    89,    90,    90,    91,    92,    92,
      93,    93,    94,    94,    95,    96,    96,    97,    97,    97,
      98,    99,    99,   100,   100,   101,   101,   102,   103,   104,
     105,   106,   106,   107,   108,   109,   110,   111,   112,   113,
     113,   114,   114,   115,   116,   117,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   119,   120,   121,   122,   122,   123,   124,
     125,   126,   127,   128,   128,   129,   129,   129,   129,   130,
     130,   131,   131,   132,   133,   133,   133,   134,   135,   135,
     135,   136,   136,   137,   138,   138,   138,   138,   138,   138,
     138,   139
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     0,     3,     1,     6,     6,     8,     1,
       0,     3,     1,     2,     4,     6,     4,     0,     3,     1,
       1,     2,     1,     1,     1,     2,     0,     3,     1,     0,
       2,     6,     3,     1,     3,     3,     1,     1,     1,     1,
       8,     2,     0,     1,     0,     2,     1,     4,     0,     6,
       0,     2,     1,     4,     6,     8,     0,     8,     0,     1,
       0,     1,     0,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     0,     2,     3,     1,     0,     2,
       2,     4,     8,     2,     4,     1,     3,     2,     4,     1,
       1,     3,     1,     3,     1,     1,     1,     4,     1,     1,
       0,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     0
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      80,    79,    70,     0,     0,   130,    68,     0,     0,     0,
     108,   115,   104,     0,     0,     0,     2,    14,     4,     5,
       6,     9,    10,    11,     0,     7,     8,    12,    13,    15,
      16,    17,    18,    19,    20,    21,     0,    57,    58,    86,
     102,    97,    95,    98,    87,    94,    93,    88,    89,    99,
     100,   101,    90,    91,    92,    96,   110,    59,     0,   128,
     129,     0,     0,    85,    84,    83,   109,   105,   107,   119,
       0,    49,   120,   117,   103,     0,    50,    53,     0,   113,
       1,     3,    30,   141,    80,    80,    76,    68,    62,    72,
       0,     0,    80,   108,   125,   126,   124,   116,   122,     0,
      48,     0,     0,     0,    56,     0,   108,     0,    29,    80,
       0,    25,     0,     0,     0,     0,     0,    80,     0,    71,
     111,     0,   127,   132,    64,   106,     0,   108,    47,   118,
       0,     0,    52,    54,   114,    37,     0,     0,    32,    80,
       0,    22,    78,    80,    80,    61,     0,     0,     0,    68,
      62,    63,    66,   121,   123,    55,     0,    33,    82,    82,
      80,     0,    82,    24,     0,     0,    73,    69,   140,   137,
     138,   136,   135,   134,   139,   133,   131,     0,     0,    65,
      51,    46,     0,     0,    81,    26,    27,     0,    31,     0,
      74,     0,     0,    80,     0,     0,    34,    36,     0,    82,
      82,    82,    82,    67,    60,    45,    44,     0,    43,    42,
      80,    39,    40,    28,   112,    77,    75,    41,     0,    35,
      38
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    15,   111,   112,   113,    17,   109,   137,   138,   157,
     210,   211,   196,    72,   101,    18,    76,    77,   103,    78,
      19,   118,   150,   151,   152,    62,    20,    36,    88,    89,
      21,    22,   115,    23,   164,    24,   185,    25,    26,    64,
      57,    27,    74,    28,    67,    68,    29,    30,    31,    32,
      33,    34,    73,    97,    98,    99,    35,    61,   122,   123,
     175,   110
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -183
static const yytype_int16 yypact[] =
{
     373,  -183,  -183,   249,   249,   -16,  -183,     6,     6,   249,
    -183,    -9,  -183,    30,    -8,    23,   -62,  -183,  -183,  -183,
    -183,  -183,  -183,  -183,    -6,  -183,  -183,  -183,  -183,  -183,
    -183,  -183,  -183,  -183,  -183,  -183,   -46,  -183,  -183,  -183,
    -183,  -183,  -183,  -183,  -183,  -183,  -183,  -183,  -183,  -183,
    -183,  -183,  -183,  -183,  -183,  -183,  -183,  -183,   -12,  -183,
    -183,     3,   -34,  -183,  -183,  -183,  -183,   -36,  -183,  -183,
     -13,   -30,  -183,   -19,  -183,   249,   -31,  -183,   -29,     4,
    -183,  -183,    50,  -183,   346,   208,  -183,  -183,   -17,  -183,
     249,   249,   288,  -183,  -183,  -183,  -183,    -5,  -183,    -7,
    -183,    67,   -13,   -57,  -183,   249,  -183,   -13,  -183,   317,
      52,  -183,    58,    19,    29,    68,    32,   346,    69,  -183,
      26,    24,    33,  -183,    72,  -183,   -13,  -183,  -183,    -5,
     249,    35,  -183,  -183,    -5,  -183,    73,   -24,  -183,   346,
      64,   138,  -183,   346,   181,  -183,    96,    62,   249,  -183,
      85,    72,  -183,  -183,  -183,  -183,    49,    -3,   111,   111,
     317,    93,   111,  -183,    97,    98,  -183,  -183,  -183,  -183,
    -183,  -183,  -183,  -183,  -183,  -183,  -183,    60,    99,  -183,
    -183,   101,   104,   106,  -183,  -183,  -183,   102,  -183,   107,
    -183,    82,    78,   288,   108,    87,  -183,  -183,    11,   111,
     111,   111,   111,  -183,  -183,  -183,  -183,   115,  -183,  -183,
      94,  -183,  -183,  -183,  -183,  -183,  -183,  -183,    11,  -183,
    -183
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -183,  -183,     0,   -82,  -183,  -183,  -183,  -183,    -1,  -183,
    -183,   -58,  -183,  -182,  -183,  -183,  -183,    56,    74,    -2,
    -183,    12,  -183,  -183,    14,   -83,  -183,  -183,  -183,    75,
    -183,  -183,  -183,  -183,  -183,  -183,   -79,  -183,  -183,   158,
    -183,  -183,  -183,  -183,  -183,   -64,  -183,  -183,  -183,  -183,
    -183,  -183,   153,   -81,    43,  -183,  -183,  -183,  -183,    22,
    -183,  -183
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -81
static const yytype_int16 yytable[] =
{
      16,    56,    58,   114,   116,    69,    69,    66,    59,   159,
     124,    81,    82,   205,   117,    94,   212,   130,   181,   131,
      63,   129,   182,    80,    87,   206,   134,   136,    95,   125,
      83,    90,    91,    92,    96,   145,   212,   183,    93,   100,
      84,   102,   133,   105,    37,    38,    85,    39,   106,   160,
      60,    70,    40,    87,    41,    71,    71,   161,    42,    43,
     207,   165,   166,   154,   107,    86,   177,   108,    44,   126,
     127,    45,   128,   104,   208,    71,   209,    46,   187,    47,
     186,    48,   139,   190,   168,    49,    50,    51,   104,   121,
     169,   140,   141,    52,    53,    54,    55,   142,   143,   144,
     130,   147,   146,   170,   149,    75,   158,   148,     1,   171,
     162,   203,   156,     2,     3,   167,   117,   172,   173,   174,
     213,   214,   215,   216,   180,   184,   189,   193,   155,     4,
     191,   192,   194,     5,   201,   199,     6,   195,     7,     8,
     197,   163,   198,   200,     9,    10,   121,    11,    12,   202,
     204,    71,     1,   217,    13,    14,   -80,     2,     3,   188,
     220,   132,   178,   119,   120,   179,    65,    79,   218,   153,
     176,     0,     0,     4,   -80,     0,     0,     5,     0,     0,
       6,     0,     7,     8,   -80,     0,     0,     0,     9,    10,
     -80,    11,    12,     0,     0,     1,     0,     0,    13,    14,
       2,     3,     0,     0,     0,     0,     0,     0,     0,   -80,
     219,     0,   -23,     0,   -23,     0,     4,     0,     0,     0,
       5,     0,     1,     6,     0,     7,     8,     2,     3,     0,
       0,     9,    10,     0,    11,    12,     0,     0,     0,     0,
       0,    13,    14,     4,     0,     0,     0,     5,     0,     0,
       6,   -23,     7,     8,     0,     0,     0,     0,     9,    10,
       0,    11,    12,    37,    38,     0,    39,     0,    13,    14,
       0,    40,     0,    41,     0,     0,   -23,    42,    43,     0,
       0,     0,     0,     0,     0,     0,     0,    44,     0,     0,
      45,     0,     0,     0,     0,     0,    46,     0,    47,     0,
      48,     0,     1,     0,    49,    50,    51,     2,     3,     0,
       0,     0,    52,    53,    54,    55,     0,     0,     0,   -23,
     -23,   -23,     0,     4,     0,     0,     0,     5,     0,     0,
       6,     1,     7,     8,     0,     0,     2,     3,     9,    10,
       0,    11,    12,   135,     0,     0,     0,     0,    13,    14,
     -23,     0,     4,     0,     0,     0,     5,     0,     0,     6,
       1,     7,     8,     0,     0,     2,     3,     9,    10,     0,
      11,    12,     0,     0,     0,     0,     0,    13,    14,   -23,
       0,     4,     0,     0,     0,     5,     0,     1,     6,     0,
       7,     8,     2,     3,     0,     0,     9,    10,     0,    11,
      12,     0,     0,     0,     0,     0,    13,    14,     4,     0,
       0,     0,     5,     0,     0,     6,     0,     7,     8,     0,
       0,     0,     0,     9,    10,     0,    11,    12,     0,     0,
       0,     0,     0,    13,    14
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-183))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       0,     3,     4,    85,    87,    14,    14,     9,    24,    33,
      92,    73,    18,   195,    31,    28,   198,    74,    21,    76,
      14,   102,    25,     0,    70,    14,   107,   109,    41,    93,
      36,    43,    29,    67,    47,   117,   218,    40,    74,    69,
      46,    60,   106,    74,    14,    15,    52,    17,    77,    73,
      66,    60,    22,    70,    24,    64,    64,   139,    28,    29,
      49,   143,   144,   127,    60,    71,   149,    17,    38,    74,
      77,    41,     5,    75,    63,    64,    65,    47,   160,    49,
     159,    51,    30,   162,    22,    55,    56,    57,    90,    91,
      28,    33,    73,    63,    64,    65,    66,    68,    30,    67,
      74,    77,    33,    41,    32,    75,    33,    74,    14,    47,
      46,   193,    77,    19,    20,    19,    31,    55,    56,    57,
     199,   200,   201,   202,    75,    14,    33,    67,   130,    35,
      33,    33,    33,    39,    52,    33,    42,    36,    44,    45,
      36,   141,    36,    36,    50,    51,   148,    53,    54,    71,
      42,    64,    14,    38,    60,    61,    18,    19,    20,   160,
     218,   105,   150,    88,    90,   151,     8,    14,    74,   126,
     148,    -1,    -1,    35,    36,    -1,    -1,    39,    -1,    -1,
      42,    -1,    44,    45,    46,    -1,    -1,    -1,    50,    51,
      52,    53,    54,    -1,    -1,    14,    -1,    -1,    60,    61,
      19,    20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,
     210,    -1,    31,    -1,    33,    -1,    35,    -1,    -1,    -1,
      39,    -1,    14,    42,    -1,    44,    45,    19,    20,    -1,
      -1,    50,    51,    -1,    53,    54,    -1,    -1,    -1,    -1,
      -1,    60,    61,    35,    -1,    -1,    -1,    39,    -1,    -1,
      42,    70,    44,    45,    -1,    -1,    -1,    -1,    50,    51,
      -1,    53,    54,    14,    15,    -1,    17,    -1,    60,    61,
      -1,    22,    -1,    24,    -1,    -1,    68,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,    -1,
      41,    -1,    -1,    -1,    -1,    -1,    47,    -1,    49,    -1,
      51,    -1,    14,    -1,    55,    56,    57,    19,    20,    -1,
      -1,    -1,    63,    64,    65,    66,    -1,    -1,    -1,    31,
      32,    33,    -1,    35,    -1,    -1,    -1,    39,    -1,    -1,
      42,    14,    44,    45,    -1,    -1,    19,    20,    50,    51,
      -1,    53,    54,    26,    -1,    -1,    -1,    -1,    60,    61,
      33,    -1,    35,    -1,    -1,    -1,    39,    -1,    -1,    42,
      14,    44,    45,    -1,    -1,    19,    20,    50,    51,    -1,
      53,    54,    -1,    -1,    -1,    -1,    -1,    60,    61,    33,
      -1,    35,    -1,    -1,    -1,    39,    -1,    14,    42,    -1,
      44,    45,    19,    20,    -1,    -1,    50,    51,    -1,    53,
      54,    -1,    -1,    -1,    -1,    -1,    60,    61,    35,    -1,
      -1,    -1,    39,    -1,    -1,    42,    -1,    44,    45,    -1,
      -1,    -1,    -1,    50,    51,    -1,    53,    54,    -1,    -1,
      -1,    -1,    -1,    60,    61
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    14,    19,    20,    35,    39,    42,    44,    45,    50,
      51,    53,    54,    60,    61,    79,    80,    83,    93,    98,
     104,   108,   109,   111,   113,   115,   116,   119,   121,   124,
     125,   126,   127,   128,   129,   134,   105,    14,    15,    17,
      22,    24,    28,    29,    38,    41,    47,    49,    51,    55,
      56,    57,    63,    64,    65,    66,    97,   118,    97,    24,
      66,   135,   103,    14,   117,   117,    97,   122,   123,    14,
      60,    64,    91,   130,   120,    75,    94,    95,    97,   130,
       0,    73,    18,    36,    46,    52,    71,    70,   106,   107,
      43,    29,    67,    74,    28,    41,    47,   131,   132,   133,
      69,    92,    60,    96,    97,    74,    77,    60,    17,    84,
     139,    80,    81,    82,    81,   110,   103,    31,    99,   107,
      96,    97,   136,   137,    81,   123,    74,    77,     5,   131,
      74,    76,    95,   123,   131,    26,    81,    85,    86,    30,
      33,    73,    68,    30,    67,    81,    33,    77,    74,    32,
     100,   101,   102,   132,   123,    97,    77,    87,    33,    33,
      73,    81,    46,    80,   112,    81,    81,    19,    22,    28,
      41,    47,    55,    56,    57,   138,   137,   103,    99,   102,
      75,    21,    25,    40,    14,   114,   114,    81,    86,    33,
     114,    33,    33,    67,    33,    36,    90,    36,    36,    33,
      36,    52,    71,    81,    42,    91,    14,    49,    63,    65,
      88,    89,    91,   114,   114,   114,   114,    38,    74,    80,
      89
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 224 "gram.y"
    { parser.asttree = (yyvsp[(1) - (1)].astnode); }
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 225 "gram.y"
    { parser.asttree = (yyvsp[(1) - (2)].astnode); }
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 229 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 230 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 231 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 232 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 233 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 234 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 235 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 236 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 237 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 238 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 239 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 240 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 241 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 242 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 243 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 244 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 245 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 246 "gram.y"
    { (yyval.astnode) = (yyvsp[(1) - (1)].astnode); }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 250 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (2)].list); }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 251 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 256 "gram.y"
    {
					check_labels_in_current_scope((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].astnode));
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].astnode));
				}
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 261 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].astnode));
				}
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 280 "gram.y"
    {
					PLpgPSM_eb_stmt *stmt;

					check_labels((yyvsp[(1) - (6)].str), (yyvsp[(6) - (6)].str));
					if ((yyvsp[(1) - (6)].str) != NULL || (yyvsp[(3) - (6)].boolean))
					{
						stmt = plpgpsm_eb_stmt(PLPGPSM_STMT_COMPOUND, NULL, (yylsp[(2) - (6)]),
								    (yyvsp[(1) - (6)].str), NULL, (yyvsp[(4) - (6)].list));
						stmt->option = (yyvsp[(3) - (6)].boolean);
					}
					else
						stmt = plpgpsm_eb_stmt(PLPGPSM_SIMPLE_BLOCK, NULL, (yylsp[(2) - (6)]),
								    (yyvsp[(1) - (6)].str), NULL, (yyvsp[(4) - (6)].list));

					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 297 "gram.y"
    {
					PLpgPSM_eb_stmt *stmt;

					check_labels((yyvsp[(1) - (6)].str), (yyvsp[(6) - (6)].str));
					stmt = plpgpsm_eb_stmt(PLPGPSM_STMT_COMPOUND, NULL, (yylsp[(2) - (6)]),
								    (yyvsp[(1) - (6)].str), NULL, (yyvsp[(4) - (6)].list));
					stmt->option = (yyvsp[(3) - (6)].boolean);

					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 308 "gram.y"
    {
					PLpgPSM_eb_stmt *stmt;

					check_labels((yyvsp[(1) - (8)].str), (yyvsp[(8) - (8)].str));
					stmt = plpgpsm_eb_stmt(PLPGPSM_STMT_COMPOUND, NULL, (yylsp[(2) - (8)]),
								    (yyvsp[(1) - (8)].str), NULL, list_concat((yyvsp[(4) - (8)].list), (yyvsp[(6) - (8)].list)));
					stmt->option = (yyvsp[(3) - (8)].boolean);

					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 321 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 322 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 327 "gram.y"
    {
					PLpgPSM_astnode *last_decl = (PLpgPSM_astnode *) llast((yyvsp[(1) - (3)].list));
					PLpgPSM_astnode_enum last = last_decl->type;

					/* ensure enabled order of declarations */
					if ((yyvsp[(3) - (3)].astnode)->type == PLPGPSM_DECLARE_VARIABLE)
					{
						if (last == PLPGPSM_DECLARE_CURSOR || last == PLPGPSM_DECLARE_HANDLER)
							yyerror("syntax error, variable declaration after cursor or handler");
					}
					else if ((yyvsp[(3) - (3)].astnode)->type == PLPGPSM_DECLARE_CONDITION)
					{
						if (last == PLPGPSM_DECLARE_CURSOR || last == PLPGPSM_DECLARE_HANDLER)
							yyerror("syntax error, condition declaration after cursor or handler");
					}
					else if ((yyvsp[(3) - (3)].astnode)->type == PLPGPSM_DECLARE_CURSOR)
					{
						if (last == PLPGPSM_DECLARE_HANDLER)
							yyerror("syntax error, cursor declaration after handler");
					}
					else if ((yyvsp[(3) - (3)].astnode)->type != PLPGPSM_DECLARE_HANDLER)
					{
						elog(ERROR, "internal error, unexpected value");
					}

					/* declared variables must be unique in DECLARE part */
					if ((yyvsp[(3) - (3)].astnode)->type == PLPGPSM_DECLARE_VARIABLE)
					{
						ListCell	*lc;
						PLpgPSM_declare_variable	*dvar;

						dvar = (PLpgPSM_declare_variable *) (yyvsp[(3) - (3)].astnode);
						foreach (lc, dvar->variables)
						{
							ListCell *dlc;
							PLpgPSM_variable   *var = (PLpgPSM_variable *) lfirst(lc);

							foreach (dlc, (yyvsp[(1) - (3)].list))
							{
								PLpgPSM_astnode *iter = (PLpgPSM_astnode *) lfirst(dlc);

								if (iter->type == PLPGPSM_DECLARE_VARIABLE)
								{
									PLpgPSM_declare_variable *dv = (PLpgPSM_declare_variable *) iter;
									ListCell	*vlc;

									foreach (vlc, dv->variables)
									{
										PLpgPSM_variable *var2 = (PLpgPSM_variable *) lfirst(vlc);

										Assert (((PLpgPSM_astnode *) lfirst(vlc))->type == PLPGPSM_VARIABLE);

										if (strcmp(var2->name, var->name) == 0)
											ereport(ERROR,
													(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("identifier \"%s\" is not unique in current scope",
														var->name),
											    parser_errposition(var->location)));
									}
								}
							}
						}
					}

					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].astnode));
				}
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 394 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].astnode));
				}
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 401 "gram.y"
    {
					PLpgPSM_declare_variable *declvar = (PLpgPSM_declare_variable *) (yyvsp[(2) - (2)].astnode);

					Assert(declvar->astnode.type == PLPGPSM_DECLARE_VARIABLE);
					declvar->lineno = plpgpsm_location_to_lineno((yylsp[(1) - (2)]));
					declvar->location = (yylsp[(1) - (2)]);
					(yyval.astnode) = (PLpgPSM_astnode *) declvar;
				}
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 410 "gram.y"
    {
					PLpgPSM_declare_condition *declcond = (PLpgPSM_declare_condition *) (yyvsp[(2) - (4)].astnode);
					PLpgPSM_condition *condition = (yyvsp[(4) - (4)].condition);

					Assert(declcond->astnode.type == PLPGPSM_DECLARE_CONDITION);
					declcond->lineno = plpgpsm_location_to_lineno((yylsp[(1) - (4)]));
					declcond->location = (yylsp[(1) - (4)]);

					if (condition != NULL)
					{
						Assert(condition->type == PLPGPSM_CONDITION_SQLSTATE);
						if (ERRCODE_TO_CATEGORY(condition->sqlstate) == ERRCODE_TO_CATEGORY(MAKE_SQLSTATE('0','0','0','0','0')))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot attach error category '00'"),
											parser_errposition(condition->location)));
						declcond->condition->sqlstate = condition->sqlstate;
						pfree(condition);
					}
					(yyval.astnode) = (PLpgPSM_astnode *) declcond;
				}
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 432 "gram.y"
    {
					PLpgPSM_declare_handler *declhandler = (PLpgPSM_declare_handler *) (yyvsp[(2) - (6)].astnode);

					Assert(declhandler->astnode.type == PLPGPSM_DECLARE_HANDLER);
					declhandler->lineno = plpgpsm_location_to_lineno((yylsp[(1) - (6)]));
					declhandler->location = (yylsp[(1) - (6)]);
					declhandler->condition_list = (yyvsp[(5) - (6)].list);
					declhandler->stmt = (yyvsp[(6) - (6)].astnode);
					declhandler->stmt->parent = (PLpgPSM_astnode *) declhandler;
					(yyval.astnode) = (PLpgPSM_astnode *) declhandler;
				}
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 444 "gram.y"
    {
					int	tok;
					PLpgPSM_declare_cursor *declcursor = (PLpgPSM_declare_cursor *) (yyvsp[(2) - (4)].astnode);

					Assert(declcursor->astnode.type == PLPGPSM_DECLARE_CURSOR);
					declcursor->lineno = plpgpsm_location_to_lineno((yylsp[(1) - (4)]));
					declcursor->location = (yylsp[(1) - (4)]);

					tok = yylex();
					if (tok != T_WORD && !is_unreserved_keyword(tok))
					{
						plpgpsm_push_back_token(tok);
						declcursor->esql = read_esql(';', 0, 0, ";", false, NULL, -1, false);
						declcursor->esql->astnode.parent = (PLpgPSM_astnode *) declcursor;
					}
					else
					{
						declcursor->esql = NULL;
					}
					(yyval.astnode) = (PLpgPSM_astnode *) declcursor;
				}
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 468 "gram.y"
    { (yyval.astnode) = declare_prefetch(); }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 472 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].condition)); }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 473 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].condition)); }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 477 "gram.y"
    { (yyval.condition) = condition(PLPGPSM_CONDITION_SQLSTATE, (yyvsp[(1) - (1)].ival), NULL, (yylsp[(1) - (1)])); }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 478 "gram.y"
    { (yyval.condition) = condition(PLPGPSM_CONDITION_NOTFOUND, MAKE_SQLSTATE('0','2','0','0','0'), NULL, (yylsp[(1) - (2)])); }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 479 "gram.y"
    { (yyval.condition) = condition(PLPGPSM_CONDITION_SQLWARNING, 0, NULL, (yylsp[(1) - (1)])); }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 480 "gram.y"
    { (yyval.condition) = condition(PLPGPSM_CONDITION_SQLEXCEPTION, 0, NULL, (yylsp[(1) - (1)])); }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 481 "gram.y"
    { (yyval.condition) = condition(PLPGPSM_CONDITION_NAMED, 0, (yyvsp[(1) - (1)].word).ident, (yylsp[(1) - (1)])); }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 485 "gram.y"
    { (yyval.condition) = condition(PLPGPSM_CONDITION_SQLSTATE, (yyvsp[(2) - (2)].ival), NULL, (yylsp[(2) - (2)])); }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 486 "gram.y"
    { (yyval.condition) = NULL; }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 491 "gram.y"
    {
					const char *sqlstatestr;

					sqlstatestr = (yyvsp[(3) - (3)].str);

					if (strlen(sqlstatestr) != 5)
						yyerror("invalid SQLSTATE code");
					if (strspn(sqlstatestr, "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ") != 5)
						yyerror("invalid SQLSTATE code");

					(yyval.ival) = MAKE_SQLSTATE(sqlstatestr[0],
									    sqlstatestr[1],
									    sqlstatestr[2],
									    sqlstatestr[3],
									    sqlstatestr[4]);
					if ((yyval.ival) == 0)
						yyerror("invalid SQLSTATE code");
				}
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 512 "gram.y"
    { }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 513 "gram.y"
    { }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 525 "gram.y"
    {
					if (list_length((yyvsp[(2) - (2)].list)) > 1)
					{
						PLpgPSM_eb_stmt *sb;

						sb = plpgpsm_eb_stmt(PLPGPSM_SIMPLE_BLOCK, NULL, (yylsp[(1) - (2)]),
									    NULL, NULL, (yyvsp[(2) - (2)].list));
						sb->astnode.is_visible = false;
						(yyval.astnode) = (PLpgPSM_astnode *) sb;

					}
					else
					{
						(yyval.astnode) = (PLpgPSM_astnode *) linitial((yyvsp[(2) - (2)].list));
					}
				}
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 542 "gram.y"
    {
					plpgpsm_push_back_token('(');

					(yyval.astnode) = (PLpgPSM_astnode *) new_stmt_assign(NULL, (yyvsp[(3) - (6)].list),
						    read_esql(';', 0, 0, ";", true, NULL, -1, false),
												    (yylsp[(1) - (6)]));
				}
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 552 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].astnode)); }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 553 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].astnode)); }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 558 "gram.y"
    {
					(yyval.astnode) = (PLpgPSM_astnode *) new_stmt_assign((yyvsp[(1) - (3)].referer), NIL, (yyvsp[(3) - (3)].esql), (yylsp[(1) - (3)]));
				}
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 564 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].referer)); }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 565 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].referer)); }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 570 "gram.y"
    {
					(yyval.referer) = new_referer(new_ident_var(NULL, (yyvsp[(1) - (1)].word).ident, (yylsp[(1) - (1)])), NULL);
				}
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 574 "gram.y"
    {
					(yyval.referer) = new_referer(new_ident_var(strVal(linitial((yyvsp[(1) - (1)].cword).idents)),
								       strVal(lsecond((yyvsp[(1) - (1)].cword).idents)),
								       (yylsp[(1) - (1)])), NULL);
				}
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 580 "gram.y"
    {
					(yyval.referer) = new_referer(new_ident_var(NULL, pstrdup((yyvsp[(1) - (1)].keyword)), (yylsp[(1) - (1)])), NULL);
				}
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 606 "gram.y"
    {
					PLpgPSM_eb_stmt *eb;
					PLpgPSM_eb_stmt *cb;
					List			*cblist;

					cast_to_boolean((yyvsp[(2) - (8)].esql));
					cb = plpgpsm_eb_stmt(PLPGPSM_CONDITIONAL_BLOCK, NULL, (yylsp[(1) - (8)]),
									    NULL, (yyvsp[(2) - (8)].esql), (yyvsp[(4) - (8)].list));
					cblist = list_make1(cb);
					if ((yyvsp[(5) - (8)].list) != NIL)
						cblist = list_concat(cblist, (yyvsp[(5) - (8)].list));
					if ((yyvsp[(6) - (8)].eb) != NULL)
						cblist = lappend(cblist, (yyvsp[(6) - (8)].eb));

					eb = plpgpsm_eb_stmt(PLPGPSM_STMT_IF, NULL, (yylsp[(1) - (8)]),
									    NULL, NULL, cblist);
					(yyval.astnode) = (PLpgPSM_astnode *) eb;
				}
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 628 "gram.y"
    {
					PLpgPSM_eb_stmt *eb;

					eb = plpgpsm_eb_stmt(PLPGPSM_CONDITIONAL_BLOCK, NULL, (yylsp[(1) - (2)]),
									    NULL, NULL, (yyvsp[(2) - (2)].list));
					(yyval.eb) = eb;
				}
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 636 "gram.y"
    {
					(yyval.eb) = NULL;
				}
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 642 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 643 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 647 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].eb)); }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 648 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].eb)); }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 653 "gram.y"
    {
					PLpgPSM_eb_stmt *eb;

					cast_to_boolean((yyvsp[(2) - (4)].esql));
					eb = plpgpsm_eb_stmt(PLPGPSM_CONDITIONAL_BLOCK, NULL, (yylsp[(1) - (4)]),
									    NULL, (yyvsp[(2) - (4)].esql), (yyvsp[(4) - (4)].list));
					(yyval.eb) = eb;
				}
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 664 "gram.y"
    { (yyval.esql) = read_esql(THEN, 0, 0, "THEN", true, NULL, -1, true); }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 692 "gram.y"
    {
					/*
					 * When opt_expr is not used, then a output is just sequences
					 * of conditional blocks. But when expr is entered, then we need
					 * allocate a variable, that will hold a result of expression
					 * and we have to join a variable and searching expressions.
					 *
					 */
					if ((yyvsp[(2) - (6)].esql) != NULL)
					{
						(yyval.astnode) = (PLpgPSM_astnode *) new_search_case((yyvsp[(2) - (6)].esql), (yyvsp[(3) - (6)].list), (yyvsp[(4) - (6)].eb), (yylsp[(1) - (6)]));
					}
					else
					{
						List	*cblist = (yyvsp[(3) - (6)].list);

						if ((yyvsp[(4) - (6)].eb) != NULL)
							cblist = lappend(cblist, (yyvsp[(4) - (6)].eb));

						(yyval.astnode) = (PLpgPSM_astnode *) plpgpsm_eb_stmt(PLPGPSM_STMT_CASE,
											NULL, (yylsp[(1) - (6)]),
												NULL, NULL,
													    cblist);
					}
				}
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 720 "gram.y"
    { (yyval.esql) = read_esql(WHEN, 0, 0, "WHEN", true, NULL, -1, true); }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 724 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].eb)); }
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 725 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].eb)); }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 730 "gram.y"
    {
					PLpgPSM_eb_stmt *eb;

					eb = plpgpsm_eb_stmt(PLPGPSM_CONDITIONAL_BLOCK, NULL, (yylsp[(1) - (4)]),
								    NULL, (yyvsp[(2) - (4)].esql), (yyvsp[(4) - (4)].list));
					(yyval.eb) = eb;
				}
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 747 "gram.y"
    {
					PLpgPSM_eb_stmt *stmt;

					check_labels((yyvsp[(1) - (6)].str), (yyvsp[(6) - (6)].str));
					stmt = plpgpsm_eb_stmt(PLPGPSM_STMT_LOOP, NULL, (yylsp[(2) - (6)]),
								    (yyvsp[(1) - (6)].str), NULL, (yyvsp[(3) - (6)].list));
					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 765 "gram.y"
    {
					PLpgPSM_eb_stmt *stmt;

					check_labels((yyvsp[(1) - (8)].str), (yyvsp[(8) - (8)].str));
					cast_to_boolean((yyvsp[(3) - (8)].esql));
					stmt = plpgpsm_eb_stmt(PLPGPSM_STMT_WHILE, NULL, (yylsp[(2) - (8)]),
								    (yyvsp[(1) - (8)].str), (yyvsp[(3) - (8)].esql), (yyvsp[(5) - (8)].list));
					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 781 "gram.y"
    { (yyval.esql) = read_esql(DO, 0, 0, "DO", true, NULL, -1, false); }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 792 "gram.y"
    {
					PLpgPSM_eb_stmt *stmt;

					check_labels((yyvsp[(1) - (8)].str), (yyvsp[(8) - (8)].str));
					cast_to_boolean((yyvsp[(5) - (8)].esql));
					stmt = plpgpsm_eb_stmt(PLPGPSM_STMT_REPEAT_UNTIL, NULL, (yylsp[(2) - (8)]),
								    (yyvsp[(1) - (8)].str), (yyvsp[(5) - (8)].esql), (yyvsp[(3) - (8)].list));
					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 808 "gram.y"
    { (yyval.esql) = read_esql(END, 0, 0, "END", true, NULL, -1, false); }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 817 "gram.y"
    {
					(yyval.str) = (yyvsp[(1) - (1)].word).ident;
					if (yylex() != ':')
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("syntax error, bizzare label \"%s\"", (yyvsp[(1) - (1)].word).ident),
										parser_errposition((yylsp[(1) - (1)]))));
				}
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 826 "gram.y"
    {
					(yyval.str) = NULL; 
				}
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 832 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].word).ident; }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 833 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 842 "gram.y"
    {
					PLpgPSM_stmt_leave_iterate *stmt = (PLpgPSM_stmt_leave_iterate *) palloc(sizeof(PLpgPSM_stmt_leave_iterate));

					stmt->astnode.type = PLPGPSM_STMT_LEAVE;
					stmt->astnode.is_visible = true;
					stmt->lineno = plpgpsm_location_to_lineno((yylsp[(1) - (2)]));
					stmt->location = (yylsp[(2) - (2)]);
					stmt->label = (yyvsp[(2) - (2)].str);
					stmt->stop_node = NULL;
					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 857 "gram.y"
    {
					PLpgPSM_stmt_leave_iterate *stmt = (PLpgPSM_stmt_leave_iterate *) palloc(sizeof(PLpgPSM_stmt_leave_iterate));

					stmt->astnode.type = PLPGPSM_STMT_ITERATE;
					stmt->astnode.is_visible = true;
					stmt->lineno = plpgpsm_location_to_lineno((yylsp[(1) - (2)]));
					stmt->location = (yylsp[(2) - (2)]);
					stmt->label = (yyvsp[(2) - (2)].str);
					stmt->stop_node = NULL;
					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 871 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].word).ident; }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 900 "gram.y"
    {
					PLpgPSM_stmt_return *stmt = (PLpgPSM_stmt_return *) palloc(sizeof(PLpgPSM_stmt_return));

					stmt->astnode.type = PLPGPSM_STMT_RETURN;
					stmt->astnode.is_visible = true;
					stmt->lineno = plpgpsm_location_to_lineno((yylsp[(1) - (2)]));
					stmt->location = (yylsp[(1) - (2)]);
					stmt->expr = (yyvsp[(2) - (2)].esql);

					if (stmt->expr != NULL)
					{
						stmt->expr->astnode.parent = (PLpgPSM_astnode *) stmt;
						if (parser.noutargs > 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("RETURN should not have a expression when OUT parameters are used"),
											parser_errposition((yylsp[(2) - (2)]))));
					}
					else if (parser.noutargs == 0 && !parser.is_void)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("RETURN should have a expression when OUT parameters are not used"),
										parser_errposition((yylsp[(1) - (2)]))));

					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 933 "gram.y"
    { (yyval.esql) = read_esql(';', 0, 0, ";", true, NULL, -1, true); }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 944 "gram.y"
    {
					PLpgPSM_stmt_print *stmt = (PLpgPSM_stmt_print *) palloc(sizeof(PLpgPSM_stmt_print));

					stmt->astnode.type = PLPGPSM_STMT_PRINT;
					stmt->astnode.is_visible = true;
					stmt->lineno = plpgpsm_location_to_lineno((yylsp[(1) - (2)]));
					stmt->location = (yylsp[(1) - (2)]);
					stmt->expr_list = (yyvsp[(2) - (2)].list);
					set_parent(stmt->expr_list, (PLpgPSM_astnode *) stmt);
					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 958 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].esql)); }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 959 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].esql)); }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 963 "gram.y"
    { (yyval.esql) = read_esql(';', ',', 0, "; or ','", true, NULL, -1, false); }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 972 "gram.y"
    {
					PLpgPSM_stmt_open *stmt = (PLpgPSM_stmt_open *) palloc(sizeof(PLpgPSM_stmt_open));

					stmt->astnode.type = PLPGPSM_STMT_OPEN;
					stmt->astnode.is_visible = true;
					stmt->lineno = plpgpsm_location_to_lineno((yylsp[(1) - (2)]));
					stmt->location = (yylsp[(1) - (2)]);

					stmt->cursor = (yyvsp[(2) - (2)].referer);
					stmt->cursor->ident->astnode.type = PLPGPSM_IDENT_CURSOR;
					stmt->cursor->astnode.parent = (PLpgPSM_astnode *) stmt;
					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 993 "gram.y"
    {
					PLpgPSM_stmt_close *stmt = (PLpgPSM_stmt_close *) palloc(sizeof(PLpgPSM_stmt_close));

					stmt->astnode.type = PLPGPSM_STMT_CLOSE;
					stmt->astnode.is_visible = true;
					stmt->lineno = plpgpsm_location_to_lineno((yylsp[(1) - (2)]));
					stmt->location = (yylsp[(1) - (2)]);

					stmt->cursor = (yyvsp[(2) - (2)].referer);
					stmt->cursor->ident->astnode.type = PLPGPSM_IDENT_CURSOR;
					stmt->cursor->astnode.parent = (PLpgPSM_astnode *) stmt;
					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 1014 "gram.y"
    {
					PLpgPSM_stmt_fetch *stmt = (PLpgPSM_stmt_fetch *) palloc(sizeof(PLpgPSM_stmt_fetch));

					stmt->astnode.type = PLPGPSM_STMT_FETCH;
					stmt->astnode.is_visible = true;
					stmt->lineno = plpgpsm_location_to_lineno((yylsp[(1) - (4)]));
					stmt->location = (yylsp[(1) - (4)]);

					stmt->cursor = (yyvsp[(2) - (4)].referer);
					stmt->cursor->ident->astnode.type = PLPGPSM_IDENT_CURSOR;
					stmt->cursor->astnode.parent = (PLpgPSM_astnode *) stmt;
					stmt->target_list = (yyvsp[(4) - (4)].list);
					set_parent(stmt->target_list, (PLpgPSM_astnode *) stmt);
					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 1047 "gram.y"
    {
					PLpgPSM_eb_stmt *stmt = (PLpgPSM_eb_stmt *) (yyvsp[(3) - (8)].astnode);

					check_labels((yyvsp[(1) - (8)].str), (yyvsp[(8) - (8)].str));

					stmt->location = (yylsp[(2) - (8)]);
					stmt->lineno = plpgpsm_location_to_lineno((yylsp[(2) - (8)]));
					stmt->label = (yyvsp[(1) - (8)].str);
					stmt->stmts = (yyvsp[(5) - (8)].list);
					set_parent(stmt->stmts, (PLpgPSM_astnode *) stmt);
					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 1068 "gram.y"
    {
					(yyval.astnode) = newsignal(PLPGPSM_STMT_SIGNAL, (yyvsp[(2) - (2)].condition), NULL, (yylsp[(1) - (2)]));
				}
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 1072 "gram.y"
    {
					(yyval.astnode) = newsignal(PLPGPSM_STMT_SIGNAL, (yyvsp[(2) - (4)].condition), (yyvsp[(4) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 1084 "gram.y"
    {
					(yyval.astnode) = newsignal(PLPGPSM_STMT_RESIGNAL, NULL, NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 1088 "gram.y"
    {
					(yyval.astnode) = newsignal(PLPGPSM_STMT_RESIGNAL, NULL, (yyvsp[(3) - (3)].list), (yylsp[(1) - (3)]));
				}
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 1092 "gram.y"
    {
					(yyval.astnode) = newsignal(PLPGPSM_STMT_RESIGNAL, (yyvsp[(2) - (2)].condition), NULL, (yylsp[(1) - (2)]));
				}
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 1096 "gram.y"
    {
					(yyval.astnode) = newsignal(PLPGPSM_STMT_RESIGNAL, (yyvsp[(2) - (4)].condition), (yyvsp[(4) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 1102 "gram.y"
    { (yyval.condition) = condition(PLPGPSM_CONDITION_NAMED, 0, (yyvsp[(1) - (1)].word).ident, (yylsp[(1) - (1)])); }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 1103 "gram.y"
    { (yyval.condition) = condition(PLPGPSM_CONDITION_SQLSTATE, (yyvsp[(1) - (1)].ival), NULL, (yylsp[(1) - (1)])); }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 1108 "gram.y"
    {
					ListCell	*l;
					PLpgPSM_signal_info *s1 = (PLpgPSM_signal_info *) (yyvsp[(3) - (3)].astnode);

					foreach(l, (yyvsp[(1) - (3)].list))
					{
						PLpgPSM_signal_info *s2 = (PLpgPSM_signal_info *) lfirst(l);

						if (s1->type == s2->type)
							yyerror("signal info already specified");
					}
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].astnode));
				}
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 1122 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].astnode));
				}
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 1129 "gram.y"
    {
					PLpgPSM_signal_info *sinfo;

					sinfo = (PLpgPSM_signal_info *) palloc(sizeof(PLpgPSM_signal_info));

					sinfo->astnode.type = PLPGPSM_SIGNAL_INFO;
					sinfo->astnode.is_visible = true;
					sinfo->location = (yylsp[(1) - (3)]);
					sinfo->lineno = plpgpsm_location_to_lineno((yylsp[(1) - (3)]));
					sinfo->type = (yyvsp[(1) - (3)].signal_info_enum);
					sinfo->expr = (yyvsp[(3) - (3)].esql);
					sinfo->expr->astnode.parent = (PLpgPSM_astnode *) sinfo;

					(yyval.astnode) = (PLpgPSM_astnode *) sinfo;
				}
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 1147 "gram.y"
    { (yyval.signal_info_enum) = PLPGPSM_SIGNAL_INFO_MESSAGE; }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 1148 "gram.y"
    { (yyval.signal_info_enum) = PLPGPSM_SIGNAL_INFO_DETAIL; }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 1149 "gram.y"
    { (yyval.signal_info_enum) = PLPGPSM_SIGNAL_INFO_HINT; }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 1160 "gram.y"
    {
					PLpgPSM_stmt_diagnostics *stmt;

					stmt = (PLpgPSM_stmt_diagnostics *) palloc(sizeof(PLpgPSM_stmt_diagnostics));
					stmt->astnode.type = PLPGPSM_STMT_DIAGNOSTICS;
					stmt->astnode.is_visible = true;
					stmt->location = (yylsp[(1) - (4)]);
					stmt->lineno = plpgpsm_location_to_lineno((yylsp[(1) - (4)]));
					stmt->diag_area = (yyvsp[(2) - (4)].diagarea);
					stmt->diag_info_list = (yyvsp[(4) - (4)].list);
					set_parent(stmt->diag_info_list, (PLpgPSM_astnode *) stmt);

					(yyval.astnode) = (PLpgPSM_astnode *) stmt;
				}
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 1177 "gram.y"
    { (yyval.diagarea) = PLPGPSM_DIAGAREA_CURRENT; }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 1178 "gram.y"
    { (yyval.diagarea) = PLPGPSM_DIAGAREA_STACKED; }
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 1179 "gram.y"
    { (yyval.diagarea) = PLPGPSM_DIAGAREA_CURRENT; }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 1183 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].astnode)); }
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 1184 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].astnode)); }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 1189 "gram.y"
    {
					PLpgPSM_diag_info *dinfo;

					dinfo = (PLpgPSM_diag_info *) palloc(sizeof(PLpgPSM_diag_info));
					dinfo->astnode.type = PLPGPSM_DIAG_INFO;
					dinfo->astnode.is_visible = true;
					dinfo->location = (yylsp[(1) - (3)]);
					dinfo->lineno = plpgpsm_location_to_lineno((yylsp[(1) - (3)]));
					dinfo->target = (yyvsp[(1) - (3)].referer);
					dinfo->target->astnode.parent = (PLpgPSM_astnode *) dinfo;
					dinfo->type = (yyvsp[(3) - (3)].diag_info_type);

					(yyval.astnode) = (PLpgPSM_astnode *) dinfo;
				}
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 1205 "gram.y"
    { (yyval.diag_info_type) = PLPGPSM_DIAGINFO_RETURNED_SQLSTATE; }
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 1206 "gram.y"
    { (yyval.diag_info_type) = PLPGPSM_DIAGINFO_RETURNED_SQLCODE; }
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 1207 "gram.y"
    { (yyval.diag_info_type) = PLPGPSM_DIAGINFO_MESSAGE_TEXT; }
    break;

  case 137:

/* Line 1806 of yacc.c  */
#line 1208 "gram.y"
    { (yyval.diag_info_type) = PLPGPSM_DIAGINFO_DETAIL_TEXT; }
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 1209 "gram.y"
    { (yyval.diag_info_type) = PLPGPSM_DIAGINFO_HINT_TEXT; }
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 1210 "gram.y"
    { (yyval.diag_info_type) = PLPGPSM_DIAGINFO_ROW_COUNT; }
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 1211 "gram.y"
    { (yyval.diag_info_type) = PLPGPSM_DIAGINFO_CONDITION_IDENTIFIER; }
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 1218 "gram.y"
    { (yyval.astnode) = for_prefetch(); }
    break;



/* Line 1806 of yacc.c  */
#line 3212 "gram.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 1221 "gram.y"


static PLpgPSM_condition *
condition(PLpgPSM_condition_enum type, int sqlstate, char *name, int location)
{
	PLpgPSM_condition *c = palloc0(sizeof(PLpgPSM_condition));

	c->astnode.type = PLPGPSM_CONDITION;
	c->astnode.is_visible = true;
	c->type = type;
	c->location = location;
	c->sqlstate = sqlstate;
	c->name = name;

	return c;
}

static PLpgPSM_astnode *
newsignal(PLpgPSM_astnode_enum type, PLpgPSM_condition *condition, List *signal_info_list, int location)
{
	PLpgPSM_stmt_signal *stmt = (PLpgPSM_stmt_signal *) palloc(sizeof(PLpgPSM_stmt_signal));

	stmt->astnode.type = type;
	stmt->astnode.is_visible = true;
	stmt->location = location;
	stmt->lineno = plpgpsm_location_to_lineno(location);
	stmt->condition = condition;
	stmt->signal_info_list = signal_info_list;
	stmt->handler = NULL;
	set_parent(stmt->signal_info_list, (PLpgPSM_astnode *) stmt);

	return (PLpgPSM_astnode *) stmt;
}

static PLpgPSM_astnode *
for_prefetch(void)
{
	char *namespace = NULL;
	char *cursor_name = NULL;
	int tok;
	PLpgPSM_eb_stmt *stmt_for;
	PLpgPSM_ESQL   *esql;
	PLpgPSM_cursor *cursor;

	/* read a possible loopvar_name */
	tok = yylex();
	if (tok == T_WORD)
	{
		int tok1;

		namespace = yylval.word.ident;
		tok1 = yylex();
		if (tok1 == AS)
		{
			/* try to read cursor name */
			tok = yylex();
			if (tok == T_WORD)
			{
				cursor_name = yylval.word.ident;
				tok1 = yylex();
				if (tok1 == CURSOR)
				{
					if (yylex() != FOR)
						yyerror("expected FOR");
				}
				else
				{
					cursor_name = NULL;
					plpgpsm_push_back_token(tok1);
					plpgpsm_push_back_token(tok);
				}
			}
			else
			plpgpsm_push_back_token(tok);
		}
		else if (tok1 == CURSOR)
		{
			cursor_name = namespace;
			namespace = NULL;
			if (yylex() != FOR)
				yyerror("expected FOR");
		}
		else
		{
			plpgpsm_push_back_token(tok1);
			plpgpsm_push_back_token(tok);
		}
	}
	else
		plpgpsm_push_back_token(tok);

	esql = read_esql(DO, 0, 0, "DO", false, NULL, -1, false);
	stmt_for = plpgpsm_eb_stmt(PLPGPSM_STMT_FOR, NULL, -1,
					    NULL, esql, NULL);

	stmt_for->namespace = namespace;
	cursor = (PLpgPSM_cursor *) palloc0(sizeof(PLpgPSM_cursor));
	cursor = (PLpgPSM_cursor *) palloc0(sizeof(PLpgPSM_cursor));
	cursor->astnode.type = PLPGPSM_CURSOR;
	cursor->astnode.is_visible = false;
	cursor->lineno = -1;
	cursor->location = -1;
	cursor->offset = parser.nvars++;

	if (cursor_name == NULL)
	{
		char	cursorname[20];

		snprintf(cursorname, sizeof(cursorname), "____%d", parser.nvars);
		cursor->name = pstrdup(cursorname);
		cursor->force_name = false;
	}
	else
	{
		cursor->name = cursor_name;
		cursor->force_name = true;
	}

	cursor->astnode.parent = (PLpgPSM_astnode *) stmt_for;
	stmt_for->cursor = cursor;

	return (PLpgPSM_astnode *) stmt_for;
}

/*
 * ensure so end label is same as begin label
*/
static void
check_labels(const char *label1, const char *label2)
{
	if (label2 != NULL && label1 == NULL)
		yyerror("syntax error, missing begin label");
	if (label2 == NULL || label1 == NULL)
		return;
	if (strcmp(label1, label2) != 0)
		yyerror("end label is defferent than begin label");
}

/*
 * list of tokens that are prohibited in expression
 *
 */
static bool
is_disallowed(int tok)
{
	switch (tok)
	{
		case BEGIN:
		case IF:
		case LOOP:
		case WHILE:
		case REPEAT:
		case RETURN:
		case ELSEIF:
		case DO:
		case SET:
		case UNTIL:
		case DEFAULT:
		case OPEN:
		case CLOSE:
		case FETCH:
		case SIGNAL:
		case RESIGNAL:
		case INTO:
		case GET:
			return true;
		default:
			return false;
	}
}

static bool
is_disallowed_in_typename(int tok)
{
	switch (tok)
	{
		case ATOMIC:
		case BEGIN:
		case CASE:
		case CONDITION:
		case DECLARE:
		case DEFAULT:
		case DO:
		case ELSE:
		case ELSEIF:
		case END:
		case FOR:
		case HANDLER:
		case IF:
		case ITERATE:
		case LEAVE:
		case LOOP:
		case NOT:
		case REPEAT:
		case RETURN:
		case SET:
		case THEN:
		case UNTIL:
		case VALUE:
		case WHEN:
		case WHILE:
		case SCROLL:
		case PRINT:
		case OPEN:
		case CLOSE:
		case FETCH:
		case INTO:
		case SIGNAL:
		case RESIGNAL:
		case GET:
		case '=':
			return true;
		default:
			return false;
	}
}

static bool
is_unreserved_keyword(int tok)
{
	switch (tok)
	{
		case AS:
		case ATOMIC:
		case CONTINUE:
		case CURSOR:
		case CURRENT:
		case DIAGNOSTICS:
		case EXIT:
		case FOUND:
		case NO:
		case NOT:
		case PRINT:
		case SCROLL:
		case SQLCODE:
		case SQLEXCEPTION:
		case SQLSTATE:
		case SQLWARNING:
		case STACKED:
		case UNDO:
		case MESSAGE_TEXT:
		case DETAIL_TEXT:
		case HINT_TEXT:
		case RETURNED_SQLCODE:
		case RETURNED_SQLSTATE:
		case CONDITION_IDENTIFIER:
		case ROW_COUNT:
			return true;
		default:
			return false;
	}
}

/*
 * Returns true, when token is end token of some statement
 *
 */
static bool
is_statement_final_token(int tok)
{
	int tok1, tok2;

	if (tok == END)
	{
		plpgpsm_peek2(&tok1, &tok2, NULL, NULL);

		switch (tok1)
		{
			case FOR:
			case CASE:
			case IF:
			case LOOP:
			case WHILE:
			case REPEAT:
				return true;
			default:
				return false;
		}
	}

	return false;
}

/*
 * One difference between PL/pgSQL and PL/pgPSM is optionality finishing semicolon
 * in PL/pgPSM. SQL/PSM allow single statements function. Just "RETURN expr" is
 * correct. So when one from "until" token is semicolon, then until token is 
 * optional. Semicolon or other delimiter is returned back.
 *
 */
static PLpgPSM_ESQL *
read_esql(int until1, int until2, int until3,
						 const char *expected,
						 bool is_expression,
						 int *endtoken,
						 int startlocation,
						 bool		is_optional)
{
	int parenlevel = 0;
	int tok;
	StringInfoData ds;
	PLpgPSM_ESQL *esql;

	bool		optional_limiter;		/* limiter is optional */
	bool		weak_limiter;			/* limiter is ignored between brackets - THEN, ',' */

	initStringInfo(&ds);

	optional_limiter = (until1 == ';' || until2 == ';' || until3 == ';');

	/*
	 * limiter should be ignored between parenthesis
	 */
	weak_limiter = (until1 == THEN || until2 == THEN || until3 == THEN
			|| until1 == WHEN || until2 == WHEN || until3 == WHEN
			|| until1 == END || until2 == END || until3 == END
			|| until1 == ',' || until2 == ',' || until3 == ',');

	for (;;)
	{
		/* read a current location before you read a next tag */
		tok = yylex();

		if (startlocation < 0)
			startlocation = yylloc;

		if (tok == 0 && optional_limiter)
		{
			if (optional_limiter)
			{
				/*
				 * in this case, there is nothing to return back, so
				 * just verify closed parenthesis.
				 *
				 */
				if (parenlevel > 0)
					yyerror("mismatched parentheses");

				if (endtoken)
					*endtoken = '\0';
				break;
			}
			else
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("missing \"%s\" at end of SQL expression",
												expected),
						 parser_errposition(yylloc)));
		}

		/*
		 * When limiter is comma or THEN, then it can be ignored under parenthesis
		 *
		 *    SET a = (10 "," 20) , b =
		 *    IF (CASE WHEN x THEN b END) THEN
		 *
		 */
		if ((tok == ',' || tok == THEN || tok == END) && weak_limiter && parenlevel > 0)
		{
			/* this is not expected limiter */
			continue;
		}
		/*
		 * Usually limiter has higher priority than parenthesis. This is identification
		 * of missing parenthesis.
		 *
		 */
		if (tok == until1 || tok == until2 || tok == until3)
		{
			if (parenlevel > 0)
				yyerror("mismatched parenthesis");

			if (endtoken)
				*endtoken = tok;
			plpgpsm_push_back_token(tok);
			break;
		}

		/*
		 * often error should be missing semicolon on end of expression. We can do
		 * some smarter and early checking - don't allow a END (IF|CASE|LOOP|REPEAT|WHILE)
		 * inside expression.
		 *
		 */
		if (is_statement_final_token(tok) || (is_disallowed(tok) && is_expression))
				yyerror("syntax error");

		if (tok == '(' || tok == '[')
			parenlevel++;
		else if (tok == ')' || tok == ']')
		{
			parenlevel--;
			if (parenlevel < 0)
				yyerror("mismatched parentheses");
		}
	}

	plpgpsm_append_source_text(&ds, startlocation, yylloc);

	if (ds.len == 0)
	{
		if (!is_optional)
			yyerror("missing expression");
		return NULL;
	}

	esql = palloc(sizeof(PLpgPSM_ESQL));

	/* try to truncate from right a returned string */
	while (isspace(ds.data[ds.len - 1]))
		ds.data[--ds.len] = '\0';

	esql->astnode.type = PLPGPSM_ESQL;
	esql->astnode.is_visible = true;

	esql->is_expression = is_expression;
	esql->location = startlocation;
	esql->lineno = plpgpsm_location_to_lineno(startlocation);
	esql->sqlstr = ds.data;
	esql->var_refs = NIL;
	esql->plan = NULL;

	return esql;
}

static PLpgPSM_ident *
read_typename()
{
	int parenlevel = 0;
	int tok;
	StringInfoData ds;
	int startlocation = -1;
	PLpgPSM_ident		*result;

	initStringInfo(&ds);

	for (;;)
	{
		/* read a current location before you read a next tag */
		tok = yylex();

		if (startlocation < 0)
			startlocation = yylloc;

		if (tok == ';' || tok == DEFAULT)
			break;

		if (tok == 0)
			yyerror("syntax error");

		if (is_disallowed_in_typename(tok))
			yyerror("syntax error");

		if (tok == '(' || tok == '[')
			parenlevel++;
		else if (tok == ')' || tok == ']')
		{
			parenlevel--;
			if (parenlevel < 0)
				yyerror("mismatched parentheses");
		}
	}

	plpgpsm_append_source_text(&ds, startlocation, yylloc);

	if (ds.len == 0)
	{
		yyerror("missing data type");
		return NULL;
	}

	/* try to truncate from right a returned string */
	while (isspace(ds.data[ds.len - 1]))
		ds.data[--ds.len] = '\0';

	plpgpsm_push_back_token(tok);

	result = (PLpgPSM_ident *) palloc(sizeof(PLpgPSM_ident));
	result->astnode.type = PLPGPSM_IDENT_TYPE;
	result->astnode.is_visible = true;
	result->name = ds.data;
	result->location = startlocation;

	return result;
}

/*
 * These states are used for controling state machine when DECLARE statement
 * is processed.
 */
typedef enum
{
	Initial = 0,
	Unknown = 1,
	EXPECTED_VARIABLE = 2,
	COMPLETE_LIST_OF_VARIABLES = 3,
	EXPECTED_DATATYPE = 4,
	EXPECTED_EXPRESSION = 5,
	EXPECTED_CURSOR = 6
} DeclareParsingState;

/*
 * Because I would to see a parser by the most simply, then
 * a parsing of declaratin part is handy written. This section needs
 * a relative large prefetch lookup.
 */
static PLpgPSM_astnode *
declare_prefetch(void)
{
	DeclareParsingState state = Initial;
	int tok;
	PLpgPSM_ident *ident = NULL;
	List	*variables = NIL;
	PLpgPSM_cursor_option cursor_option = 0;

	for (;;)
	{
		if (state == EXPECTED_DATATYPE)
		{
			PLpgPSM_ident *typename;
			PLpgPSM_ESQL *defexpr;

			typename = read_typename();

			if ((tok = yylex()) == DEFAULT)
				defexpr = read_esql(';', 0, 0, ";", true, NULL, -1, false);
			else
			{
				defexpr = NULL;
				plpgpsm_push_back_token(tok);
			}

			if (variables == NIL)
				variables = list_make1(plpgpsm_new_variable(ident->name, ident->location));

			return (PLpgPSM_astnode *) new_declvar(variables, typename, defexpr);
		}

		if (state == EXPECTED_CURSOR)
		{
			PLpgPSM_declare_cursor *declcur;
			PLpgPSM_cursor *cursor;

			tok = yylex();
			Assert(tok == CURSOR);

			cursor = (PLpgPSM_cursor *) palloc0(sizeof(PLpgPSM_cursor));
			cursor->astnode.type = PLPGPSM_CURSOR;
			cursor->lineno = plpgpsm_location_to_lineno(ident->location);
			cursor->location = ident->location;
			cursor->offset = parser.nvars++;
			cursor->name = ident->name;
			cursor->force_name = false;

			declcur = (PLpgPSM_declare_cursor *) palloc0(sizeof(PLpgPSM_declare_cursor));
			declcur->astnode.type = PLPGPSM_DECLARE_CURSOR;
			declcur->astnode.is_visible = true;
			declcur->cursor = cursor;
			declcur->cursor->astnode.parent = (PLpgPSM_astnode *) declcur;
			declcur->option = cursor_option;

			plpgpsm_push_back_token(tok);

			return (PLpgPSM_astnode *) declcur;
		}

		if ((tok = yylex()) == 0)
			yyerror("unpexpected end of function definition");

		if (state == Initial)
		{
			if (tok == T_WORD)
			{
				/* store identifier */
				ident = new_ident_var(NULL, yylval.word.ident, yylloc);
				state = Unknown;
				continue;
			}
			else if (tok == CONTINUE || tok == EXIT || tok == UNDO)
			{
				int tok1;
				const char *varname = yylval.keyword; /* store pointer for possible later usage */

				/*
				 * recheck next symbol, when next token is HANDLER,
				 * then we found a handler's declaration, otherwise
				 * it's variable declaration.
				 */
				if ((tok1 = yylex()) == HANDLER)
				{
					PLpgPSM_declare_handler *declhandler;

					declhandler = (PLpgPSM_declare_handler *) palloc(sizeof(PLpgPSM_declare_handler));
					declhandler->astnode.type = PLPGPSM_DECLARE_HANDLER;
					switch (tok)
					{
						case CONTINUE:
							declhandler->handler_type = PLPGPSM_HANDLER_CONTINUE;
							break;
						case EXIT:
							declhandler->handler_type = PLPGPSM_HANDLER_EXIT;
							break;
						case UNDO:
							declhandler->handler_type = PLPGPSM_HANDLER_UNDO;
							break;
					}

					plpgpsm_push_back_token(tok1);

					return (PLpgPSM_astnode *) declhandler;
				}
				else
				{
					ident = new_ident_var(NULL, pstrdup(varname), yylloc);
					state = Unknown;
					continue;
				}
			}
			else if (is_unreserved_keyword(tok))
			{
				ident = new_ident_var(NULL, yylval.word.ident, yylloc);
				state = Unknown;
				continue;
			}
		}

		if (state == Unknown)
		{
			if (tok == ',')
			{
				/* store identificator */
				state = EXPECTED_VARIABLE;
				continue;
			}
			else if (tok == CONDITION)
			{
				PLpgPSM_declare_condition *declcond;

				declcond = (PLpgPSM_declare_condition *) palloc(sizeof(PLpgPSM_declare_condition));
				declcond->astnode.type = PLPGPSM_DECLARE_CONDITION;
				declcond->astnode.is_visible = true;

				declcond->condition = condition(PLPGPSM_CONDITION_NAMED, 0, ident->name, ident->location);
				declcond->astnode.parent = (PLpgPSM_astnode *) declcond;
				pfree(ident);

				plpgpsm_push_back_token(tok);

				return (PLpgPSM_astnode *) declcond;
			}
			else if (tok == CURSOR)
			{
				cursor_option = PLPGPSM_CURSOR_NOSCROLL;
				state = EXPECTED_CURSOR;

				plpgpsm_push_back_token(tok);

				continue;
			}
			else if (tok == SCROLL)
			{
				int tok1;

				tok1 = yylex();
				if (tok1 == CURSOR)
				{
					cursor_option = PLPGPSM_CURSOR_SCROLL;
					state = EXPECTED_CURSOR;

					plpgpsm_push_back_token(tok);

					continue;
				}
				else
				{
					state = EXPECTED_DATATYPE;

					plpgpsm_push_back_token(tok1);
					plpgpsm_push_back_token(tok);

					continue;
				}
			}
			else if (tok == NO)
			{
				int tok1;

				tok1 = yylex();
				if (tok1 != SCROLL)
				{
					state = EXPECTED_DATATYPE;

					plpgpsm_push_back_token(tok1);
					plpgpsm_push_back_token(tok);

					continue;
				}
				else
				{
					int tok2 = yylex();

					if (tok2 != CURSOR)
					{
						state = EXPECTED_DATATYPE;

						plpgpsm_push_back_token(tok2);
						plpgpsm_push_back_token(tok1);
						plpgpsm_push_back_token(tok);

						continue;
					}
					else
					{
						state = EXPECTED_CURSOR;
						cursor_option = PLPGPSM_CURSOR_NOSCROLL;

						plpgpsm_push_back_token(tok2);

						continue;
					}
				}
			}
			else if (tok == T_WORD || is_unreserved_keyword(tok))
			{
				state = EXPECTED_DATATYPE;

				plpgpsm_push_back_token(tok);

				continue;
			}
		}

		if (state == EXPECTED_VARIABLE)
		{
			ListCell	*lc;

			if (tok != T_WORD && !is_unreserved_keyword(tok))
				yyerror("missing a variable identifier");

			foreach (lc, variables)
			{
				PLpgPSM_variable *variable = (PLpgPSM_variable *) lfirst(lc);

				if (strcmp(variable->name, yylval.word.ident) == 0)
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("variable \"%s\" is not unique", yylval.word.ident),
								     parser_errposition(yylloc)));
			}

			if (variables != NIL)
				variables = lappend(variables, plpgpsm_new_variable(yylval.word.ident, yylloc));
			else
				variables = list_make2(plpgpsm_new_variable(ident->name, ident->location),
							plpgpsm_new_variable(yylval.word.ident, yylloc));

			state = COMPLETE_LIST_OF_VARIABLES;

			continue;
		}

		if (state == COMPLETE_LIST_OF_VARIABLES)
		{
			if (tok == ',')
			{
				/* do nothing */
				state = EXPECTED_VARIABLE;

				continue;
			}
			else
			{
				state = EXPECTED_DATATYPE;

				plpgpsm_push_back_token(tok);

				continue;
			}
		}

		yyerror("syntax error");
	}

	elog(ERROR, "unexpeced error");

	return NULL;
}

/*
 * Ensure unique label in statement scope
 *
 */
static void
check_labels_in_current_scope(List *stmts, PLpgPSM_astnode *stmt)
{
	if (plpgpsm_allow_cast_to_eb(stmt))
	{
		char *label = ((PLpgPSM_eb_stmt *) stmt)->label;

		if (label != NULL)
		{
			ListCell	*lc;

			foreach (lc, stmts)
			{
				PLpgPSM_astnode *astnode = (PLpgPSM_astnode *) lfirst(lc);

				if (plpgpsm_allow_cast_to_eb(astnode))
				{
					char *label2 = ((PLpgPSM_eb_stmt *) astnode)->label;

					if (label2 != NULL && strcmp(label, label2) == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
					errmsg("label \"%s\" is not unique in current scope", label),
					     parser_errposition(((PLpgPSM_eb_stmt *) stmt)->location)));
				}
			}
		}
	}
}

/*
 * ensure setting of correct parent for all nodes in list
 *
 */
static void 
set_parent(List *nodes, PLpgPSM_astnode *parent)
{
	ListCell	*lc;

	foreach (lc, nodes)
	{
		((PLpgPSM_astnode *) lfirst(lc))->parent = parent;
	}
}

/*
 * Simple aux. routines
 *
 */

static PLpgPSM_referer *
new_referer(PLpgPSM_ident *ident, PLpgPSM_astnode *ref)
{
	PLpgPSM_referer *referer = (PLpgPSM_referer *) palloc(sizeof(PLpgPSM_referer));

	referer->astnode.type = PLPGPSM_REFERER;
	referer->astnode.is_visible = false;
	referer->ident = ident;
	referer->ref = ref;
	ident->astnode.parent = (PLpgPSM_astnode *) referer;

	return referer;
}

static PLpgPSM_ident *
new_ident_var(char *scope, char *name, int location)
{
	PLpgPSM_ident *ident = (PLpgPSM_ident *) palloc(sizeof(PLpgPSM_ident));

	ident->astnode.type = PLPGPSM_IDENT_VARIABLE;
	ident->astnode.is_visible = true;
	ident->scope = scope;
	ident->name = name;
	ident->location = location;

	return ident;
}

static PLpgPSM_stmt_assign *
new_stmt_assign(PLpgPSM_referer *referer, List *idents, PLpgPSM_ESQL *expr, int location)
{
	PLpgPSM_stmt_assign *stmt = (PLpgPSM_stmt_assign *) palloc(sizeof(PLpgPSM_stmt_assign));

	stmt->astnode.type = PLPGPSM_STMT_ASSIGN;
	stmt->astnode.is_visible = true;
	stmt->location = location;
	stmt->lineno = location != -1 ? plpgpsm_location_to_lineno(location) : -1;
	stmt->expr = expr;
	stmt->expr->astnode.parent = (PLpgPSM_astnode *) stmt;
	stmt->target = referer;
	stmt->target_list = idents;

	if (stmt->target != NULL)
	{
		stmt->target->astnode.parent = (PLpgPSM_astnode *) stmt;
	}
	else if (list_length(stmt->target_list) == 1)
	{
		stmt->target = linitial(stmt->target_list);
		stmt->target->astnode.parent = (PLpgPSM_astnode *) stmt;
		stmt->target_list = NIL;
	}
	else
	{
		stmt->target = NULL;
		set_parent(stmt->target_list, (PLpgPSM_astnode *) stmt);
	}

	return stmt;
}

/*
 * result of this rule will be hiearchy:
 *  compound statement
 *    -> declare variable
 *    -> case
 *       -> assign statement
 *       -> conditional block
 *          -> stmts
 *
 * This technique is mix of AST and bytecode, I would not increase
 * complexity of CASE statement execution. Assign statement is inside
 * CASE statement, because it is invisible, and when evaluation of
 * expression raises expression, then we would to find CASE as a nearest
 * outer visible statement.
 *
 */
static PLpgPSM_eb_stmt *
new_search_case(PLpgPSM_ESQL *expr, List *case_when_list, PLpgPSM_eb_stmt *else_stmts, int location)
{
	PLpgPSM_variable *case_var;
	PLpgPSM_declare_variable *dvar;
	PLpgPSM_eb_stmt *case_stmt;
	ListCell		*lc;
	List		*cblist;
	char	varname[20];
	PLpgPSM_stmt_assign *assign_stmt;
	PLpgPSM_eb_stmt *result;
	PLpgPSM_ident *fake_ident;

	snprintf(varname, sizeof(varname), "____%d", parser.nvars);
	case_var = plpgpsm_new_variable(pstrdup(varname), location);
	case_var->astnode.is_visible = false;

	dvar = new_declvar(list_make1(case_var), NULL, NULL);
	dvar->astnode.is_visible = false;

	fake_ident = new_ident_var(NULL, pstrdup(varname), -1);
	fake_ident->astnode.is_visible = false;

	assign_stmt = new_stmt_assign(new_referer(fake_ident, NULL),
									NIL, expr, -1);
	assign_stmt->astnode.is_visible = false;

	cblist = list_make1(assign_stmt);
	cblist = list_concat(cblist, case_when_list);
	if (else_stmts != NULL)
		cblist = lappend(cblist, else_stmts);

	case_stmt =  plpgpsm_eb_stmt(PLPGPSM_STMT_CASE,
							NULL, location,
								NULL, NULL,
								    cblist);

	result = plpgpsm_eb_stmt(PLPGPSM_STMT_COMPOUND,
							NULL, location,
								NULL, NULL,
							list_make2(dvar, case_stmt));

	result->astnode.is_visible = false;

	/* modify a conditional blocks */
	foreach (lc, case_when_list)
	{
		PLpgPSM_eb_stmt *cb = (PLpgPSM_eb_stmt *) lfirst(lc);

		Assert(((PLpgPSM_astnode *) lfirst(lc))->type == PLPGPSM_CONDITIONAL_BLOCK);

		if (cb->expr != NULL)
		{
			StringInfoData		ds;

			if (expr != NULL)
			{
				initStringInfo(&ds);
				appendStringInfo(&ds, "(%s IN(%s))", varname, cb->expr->sqlstr);

				/* release previous expression */
				pfree(cb->expr->sqlstr);
				cb->expr->sqlstr = ds.data;
				cb->expr->location -= (strlen(varname) + 4);

				/* remove location, when is wrong */
				if (cb->expr->location < 0)
					cb->expr->location = -1;
			}
			else if (cb->expr != NULL)
				cast_to_boolean(cb->expr);
		}
	}

	return result;
}

/*
 * Enhance expression with cast to boolean
 *
 * This fragment should be removed if we can to specify target
 * type for expressions.
 *
 */
static void
cast_to_boolean(PLpgPSM_ESQL *expr)
{
	StringInfoData		ds;

	if (!expr->is_expression)
		elog(ERROR, "cannot to cast query to boolean");

	initStringInfo(&ds);
	appendStringInfo(&ds, "(%s)::boolean", expr->sqlstr);
	pfree(expr->sqlstr);
	expr->sqlstr = ds.data;
	(expr->location)--;
}

static PLpgPSM_declare_variable *
new_declvar(List *variable_list, PLpgPSM_ident *typename, PLpgPSM_ESQL *expr)
{
	PLpgPSM_declare_variable *declvar;

	declvar = (PLpgPSM_declare_variable *) palloc(sizeof(PLpgPSM_declare_variable));

	declvar->astnode.type = PLPGPSM_DECLARE_VARIABLE;
	declvar->astnode.is_visible = true;
	declvar->location = -1;
	declvar->variables = variable_list;
	declvar->typename = typename;
	declvar->expr = expr;
	if (declvar->expr != NULL)
		declvar->expr->astnode.parent = (PLpgPSM_astnode *) declvar;

	set_parent(declvar->variables, (PLpgPSM_astnode *) declvar);

	return declvar;
}

